您的位置:首页 > 产品设计 > UI/UE

300.LeetCode Longest Increasing Subsequence(medium)[动态规划]

2016-03-29 21:47 549 查看
Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,

Given 
[10, 9, 2, 5, 3, 7, 101, 18]
,

The longest increasing subsequence is 
[2, 3, 7, 101]
, therefore the length is 
4
.
Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

这里要求最长增长子序列,那么采用动态规划的思想,对于每个元素位置的最长增长子序列是该元素之前的比当前元素小的最大增长子序列的长度加上1.

class Solution {
public:
int lengthOfLIS(vector<int>& nums) {
if(nums.size()<=1)
return nums.size();
int n = nums.size();
vector<int> dp(n);
dp[0] = 1;
for(int i=1;i<n;i++)
{
int max = 0;
for(int j=0;j<i;j++)
{
if(nums[j]<nums[i])
{
if(max<dp[j])
max = dp[j];
}
}
dp[i] = max+1;
}
sort(dp.begin(),dp.end());
return dp[n-1];
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: